using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Data;
using System.Xml;
using System.Web;
using System.Threading;
using System.Globalization;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.Security.Principal;
using SK.MemberBLL;

namespace SK.MemberWeb
{
	/// <summary>
	/// ҳ
	/// </summary>
	public class BasePage : System.Web.UI.Page
	{

		public BasePage()
		{
			this.Load += new System.EventHandler(this.SorkeSitePage_Load);

		}
		private void SorkeSitePage_Load(object sender, System.EventArgs e) 
		{

			for(int i =0;i<this.Controls.Count;i++)
			{
				if(this.Controls[i].GetType()==typeof(System.Web.UI.HtmlControls.HtmlForm))
				{
					for(int j =0;j<this.Controls[i].Controls.Count;j++)
					{
						if(this.Controls[i].Controls[j].GetType()==typeof(SK.MemberWeb.Controls.ControlHolder))
						{
							string PlaceHolderName = ((SK.MemberWeb.Controls.ControlHolder)this.Controls[i].Controls[j]).Src;
							System.Web.UI.Control hdrCtl = null;
							hdrCtl = LoadControl(TemplatePath+PlaceHolderName+".ascx");
							if (hdrCtl != null)
							{
								this.Controls[i].Controls[j].Controls.Add(hdrCtl);
							}
						}
					}
				}
			}
		}
		public string SubString(object INTRO,int Length)
		{
			return Utils.SubString(INTRO.ToString(),Length);
		}
		public void DisplayAlert (string message)
		{
			RegisterClientScriptBlock(Guid.NewGuid().ToString(), "<script language=\"JavaScript\">" + GetAlertScript(message) + "</script>");
		}
		
		public string GetAlertScript(string message)
		{
			return "alert('" + message.Replace("'", "\\'") + "');";
		}
		
		public void GiveFocus (Control c)
		{
			RegisterClientScriptBlock("CSP-focus-function", "<script language=\"JavaScript\">" + "\n" + "function CSP_focus(id) {" + "  var o = document.getElementById(id); if (o != null) o.focus(); " + "}" + "\n" + "</script>");
			
			RegisterStartupScript("CSP-focus", "<script language=\"JavaScript\">CSP_focus('" + c.ClientID + "');</script>");
		}
		public void ExecuteControl (Control c)
		{
			base.Page.RegisterClientScriptBlock("CSP-execute-function", "<script language=\"JavaScript\">" + "\n" + "function CSP_execute(id) {" + "  var o = document.getElementById(id); if(event.keyCode == 13) o.onclick(); " + "}" + "\n" + "</script>");
			
		}
		public string GetExecuteControlScript (Control c)
		{
			base.Page.RegisterClientScriptBlock("CSP-execute-function", "<script language=\"JavaScript\">" + "\n" + "function CSP_execute(id) {" + "  var o = document.getElementById(id); if(event.keyCode == 13){event.keyCode=9; event.returnValue = false;o.click();} " + "}" + "\n" + "</script>");
			return "CSP_execute('"+c.ClientID+"');";
			
			
		}
		public void DisplayPopup (string url, string options)
		{
			RegisterStartupScript(Guid.NewGuid().ToString(), "<script language=\"JavaScript\">" + GetPopupScript(url, options) + "</script>");
		}
		
		public string GetPopupScript(string url, string options)
		{
			return "var w = window.open(\"" + url + "\", null, \"" + options + "\");";
		}
		public void ShowDialog (string url, string options,bool refresh)
		{
			RegisterStartupScript(Guid.NewGuid().ToString(), "<script language=\"JavaScript\">" + GetDialogScript(url, options,refresh) + "</script>");
		}
		public string GetDialogScript(string url, string options,bool refresh)
		{
			string script ="";
			if(url.IndexOf("?")>-1)
				url += "&rnd="+System.Guid.NewGuid().ToString();
			else
				url += "?rnd="+System.Guid.NewGuid().ToString();
			script = "var w=window.showModalDialog(\""+ url +"\",null,\"" + options + "\");";
			if(refresh)
				script += "if (w!=null) window.location.reload();";
			script += "return false;";
			return script;
		}
		public string GetDialogScript(string url, string options,string control)
		{
			string script = "";
			if(url.IndexOf("?")>-1)
				url += "&rnd="+System.Guid.NewGuid().ToString();
			else
				url += "?rnd="+System.Guid.NewGuid().ToString();
			script += "var w=window.showModalDialog(\""+ url +"\",null,\"" + options + "\");";
			script += "if (w!=null) document.all('"+control+"').value=w;";
			script += "return false;";
			return script;
		}
		public string GetDialogScript(string url, string options,string control,string img)
		{
			string script = "";
			if(url.IndexOf("?")>-1)
				url += "&rnd="+System.Guid.NewGuid().ToString();
			else
				url += "?rnd="+System.Guid.NewGuid().ToString();
			script += "var w=window.showModalDialog(\""+ url +"\",null,\"" + options + "\");";
			script += "if (w!=null) document.all('"+control+"').value=w;document.all('"+img+"').src=w;";
			script += "return false;";
			return script;
		}
		public void CloseWindow (bool refreshParent)
		{
			RegisterClientScriptBlock("CSP-close-popup", "<script language=\"JavaScript\">" + GetCloseWindowScript(refreshParent) + "</script>");
		}

		public string GetCloseWindowScript(bool refreshParent)
		{
			string script="";
			if (refreshParent)
			{
				script += "window.opener.location.reload();";
			}
			
			return script+"self.close();";
		}

		public void CloseDialog (bool refreshParent)
		{
			RegisterClientScriptBlock("CSP-close-dialog", "<script language=\"JavaScript\">" + GetCloseDialogScript(refreshParent) + "</script>");
		}
		public void CloseDialog (string returnValue)
		{
			RegisterClientScriptBlock("CSP-close-dialog", "<script language=\"JavaScript\">" + GetCloseDialogScript(true,returnValue) + "</script>");
		}
		public string GetCloseDialogScript(bool refreshParent)
		{
			string script="";
			if (refreshParent)
			{
				script += "window.returnValue='ok';";
			}
			
			return script+"self.close();";
		}
		public string GetCloseDialogScript(bool refreshParent,string returnValue)
		{
			string script="";
			if (refreshParent)
			{
				script += "window.returnValue='"+returnValue+"';";
			}
			
			return script+"self.close();";
		}
		protected void RegisterOnchangeScript ()
		{
			if (! IsClientScriptBlockRegistered("CSP-onchange-function"))
			{
				RegisterClientScriptBlock("CSP-onchange-function", "<script language=\"JavaScript\">" + "var isDirty= false;" + "\n" + "function CSP_checkForChange(msg) {" + "\n" + "  if (isDirty) return confirm(msg); else return true;" + "\n" + "}" + "\n" + "</script>");
			}
		}
		
		public void MonitorChanges (WebControl c)
		{
			RegisterOnchangeScript();
			if (c is CheckBox | c is CheckBoxList | c is RadioButtonList)
			{
				c.Attributes["onclick"] = "isDirty = true;";
			}
			else
			{
				c.Attributes["onchange"] = "isDirty = true;";
			}
		}
		
		public void ConfirmOnExit (WebControl c, string message)
		{
			RegisterOnchangeScript();
			c.Attributes["onclick"] = "return CSP_checkForChange('" + message.Replace("'", "\\'") + "');";
		}
		
		public void ConfirmOnChange (DropDownList ddl, string message)
		{
			if (! IsStartupScriptRegistered("CSP-ddl-onchange"))
			{
				RegisterStartupScript("CSP-ddl-onchange", "<script language=\"JavaScript\">" + "var CSP_savedDDLID = document.getElementById('" + ddl.ClientID + "').value;" + "\n" + "function resetDDLIndex() {" + "\n" + "   document.getElementById('" + ddl.ClientID + "').value = CSP_savedDDLID;" + "\n" + "}" + "\n" + "</script>");
			}
			
			ddl.Attributes["onchange"] = "if (!confirm('" + message.Replace("'", "\\'") + "')) resetDDLIndex(); else ";
		}
		public bool IsDateTime(object datetime)
		{
			try
			{
				DateTime.Parse(String.Format("{0:yyyy-MM-dd}",datetime));
				return true;
			}
			catch
			{
				return false;
			}
		}
		
		public object CurrentMemberID
		{
			get
			{
				if(HttpContext.Current.User.Identity.IsAuthenticated)
				{
					string[] parts = HttpContext.Current.User.Identity.Name.Split(';');
					return Convert.ToInt32(parts[0]);
				}
				else
					return null;
			}
		}
		public object CurrentMemberName
		{
			get
			{
				if(HttpContext.Current.User.Identity.IsAuthenticated)
				{
					string[] parts = HttpContext.Current.User.Identity.Name.Split(';');
					return parts[1];
				}
				else
					return null;
			}
		}
		public string FormatScript(string str)
		{
			return str.Replace("\r\n","\\r\\n").Replace("'", "\\'").Replace("\\", "\\\\");
		}
		public void AlertAndRedir (string message,string url)
		{
			RegisterClientScriptBlock(Guid.NewGuid().ToString(), "<script language=\"JavaScript\">" + GetAlertScript(message) + "window.location.href =\""+url+"\"; " + "</script>");
		}
		public string Root
		{
			get 
			{
				try
				{
					string path = HttpContext.Current.Request.ApplicationPath;
					if(!path.EndsWith("/")) path += "/";


					return path;
				}
				catch(Exception)
				{
					return "/";
				}
			}
		}
		public string TemplateName
		{
			get{return Main.GetValue("TemplateName").ToString();}
		}
		public string TemplatePath
		{
			get{return Root+"templates/"+TemplateName+"/";}
		}
		public static string TextToHtml(object str)
		{
			return str.ToString().Replace("\n","<br>").Replace(" ","&nbsp;").Replace("","&nbsp;&nbsp;");
		}
		public string MonthAndDay(object datetime)
		{
			DateTime t = Convert.ToDateTime(datetime);
			return String.Format("{0}-{1}",t.Month,t.Day);
		}
		public static string GetCustomText(object CustomName)
		{
			CustomTextSystem txt = new CustomTextSystem();
			return txt.GetContent(CustomName);
		}
		public static string GetValue(object Name)
		{
			return Main.GetValue(Name.ToString()).ToString();
		}
		public string Domain
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["Domain"].ToString();
			}
		}
	}
}
